/*-
 * ~~~~~~licensing~~~~~~
 * core-support-runtime
 * ==========
 * Copyright (C) 2020 - 2024 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.support.runtime.cxf;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.nio.file.Path;
import java.nio.file.Paths;

import org.osgi.framework.wiring.BundleWiring;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class EntaxyCxfClassFolderUnwrapper extends EntaxyCxfDelegatingClassUnwrapper {

	private static final Logger log = LoggerFactory.getLogger(EntaxyCxfClassFolderUnwrapper.class);
	
	protected String classesFolder;
	
	protected ClassLoader createClassLoader() {
		if (classesFolder != null) {
			URLClassLoader cl = null;
			if (delegate == null) {
				Path rootPath = Paths.get(System.getProperty("karaf.home"), classesFolder);
				try {
					cl = new URLClassLoader(
								new URL[] {rootPath.toUri().toURL()}
								, this.bundleContext==null
									?this.getClass().getClassLoader()
									:this.bundleContext.getBundle().adapt(BundleWiring.class).getClassLoader()
							);
				} catch (MalformedURLException e) {
					log.error("Malformed url for [" + rootPath + "]", e);
				}
			}
			return cl;
		}
		return null;
	}

	public String getClassesFolder() {
		return classesFolder;
	}

	public void setClassesFolder(String classesFolder) {
		this.classesFolder = classesFolder;
	}
	
}
